import java.util.Random;

public class Quilt {
	private final int[][] content;

	/**
	 * Creates a new empty quilt
	 * 
	 * @param h
	 *            Number of rows
	 * 
	 * @param b
	 *            Number of columns
	 * 
	 * @param s
	 *            Number of patterns
	 * 
	 * @param q
	 *            Number of patches per pattern
	 */
	public Quilt(int h, int b, int s, int q) {
		Random rdm = new Random();
		int actualNumber = rdm.nextInt(3);

		content = new int[h][b];
		for (int i = 0; i < content.length; i++) {
			for (int j = 0; j < content[0].length; j++) {
				content[i][j] = -1;
			}
		}

		int[] index = new int[s];
		// helpInt hilft dabei dass das Programm sich nicht festfhrt
		int helpInt = 1;
		boolean helpBool = false;

		while (stillInProgress(content)) {
			helpBool=false;
			if (helpInt % 2 == 0)
				actualNumber++;
			if (actualNumber >= s)
				actualNumber = 0;
			for (int i = 0; i < content.length; i++) {
				for (int j = 0; j < content[0].length; j++) {
					if (content[i][j] == -1)
						if (checkOtherNumbers(content, i, j, actualNumber)) {
							content[i][j] = actualNumber;
							if (nextNumber(index, actualNumber, q)) {
								actualNumber++;
								helpBool = true;
								break;
							}
						}
				}
				if (helpBool)
					break;
			}
			helpInt++;
		}
	}

	/**
	 * Hier wird geprft ob das Ergebnis vollstndig ist. Es wird jedes Element
	 * getestet ob es ungleich -1 ist.
	 * 
	 * @param content
	 *            Beherbergt das aktuelle Array mit den Werten
	 * 
	 * @return false Wenn noch Elemente nicht zugewiesen wurden
	 * @return true Wenn noch Elemente nicht zugewiesen wurden
	 */
	public boolean stillInProgress(int[][] content) {
		for (int i = 0; i < content.length; i++) {
			for (int j = 0; j < content[0].length; j++) {
				if (content[i][j] == -1)
					return true;
			}
		}
		return false;

	}

	/**
	 * Hier wird geschaut welche Nummer als nchstes kommt und ob berhaupt die
	 * nchste Nummer schon kommt. Festgemacht wird dies an der maxAnzahl.
	 * 
	 * @param index
	 *            Hlt den aktuellen Index bereit. Hier ist zu erkennen von
	 *            welchem Stoff wie viel bereits benommen wurde
	 * 
	 * @param number
	 *            Aktuelle Zahl bzw. Stoffsorte
	 * 
	 * @param maxCount
	 *            maximale Anzahl an Vorkommen einer Stoffsorte
	 * 
	 * @return false Wenn noch Elemente nicht zugewiesen wurden
	 * @return true Wenn alle Elemente zugewiesen wurden
	 */
	public boolean nextNumber(int[] index, int number, int maxCount) {

		index[number]++;
		if (index[number] == maxCount)
			return true;
		return false;

	}

	/**
	 * berprft die umliegenden Zahlen. Falls hier welche dabei sind die der
	 * aktuellen Nummer entsprechen. So wird einfach falsch zurckgegeben.
	 * 
	 * @param array
	 *            Ein Container fr die bereits zugeteilten Zahlen/Stoffe
	 * 
	 * @param bA
	 *            Zahl fr die Breite des Quilt
	 * 
	 * @param hA
	 *            Zahl fr die Hhe des Quilt
	 * 
	 * @param actNumber
	 *            aktuelle Nummer der Stoffsorte
	 * 
	 * @return false Wenn die umliegenden Elemente keine Konflikte auslsen /
	 *         unterschiedlich
	 * @return true Wenn die umliegenden Elemente Konflikte auslsen / nicht
	 *         unterschiedlich
	 */
	public boolean checkOtherNumbers(int[][] array, int bA, int hA, int actNumber) {
		bA--;
		hA--;
		// berprft alles Elemente der umliegenden Stoffsorten
		// Prft auch felder die nicht mehr im Array liegen
		// Fehlerbehandeln ber Try Catch
		if (proofedNumber(array, bA, hA, actNumber))
			if (proofedNumber(array, bA, ++hA, actNumber))
				if (proofedNumber(array, bA, ++hA, actNumber)) {
					bA++;
					hA -= 2;
					if (proofedNumber(array, bA, hA, actNumber))
						if (proofedNumber(array, bA, ++hA, actNumber))
							if (proofedNumber(array, bA, ++hA, actNumber)) {
								bA++;
								hA -= 2;
								if (proofedNumber(array, bA, hA, actNumber))
									if (proofedNumber(array, bA, ++hA, actNumber))
										if (proofedNumber(array, bA, ++hA, actNumber))
											// aktNumber lst keinen Konflikt
											// aus
											return true;
							}
				}
		return false;
	}

	/**
	 * Testet die einzelnen Nummer bzw Stoffsorte ob sie fr das entsprechende
	 * Elemente gewhlt werden darf.
	 * 
	 * @param array
	 *            Ein Container fr die bereits zugeteilten Zahlen/Stoffe
	 * 
	 * @param bA
	 *            Zahl fr die Breite des Quilt
	 * 
	 * @param hA
	 *            Zahl fr die Hhe des Quilt
	 * 
	 * @param aktNumber
	 *            aktuelle Nummer der Stoffsorte
	 * 
	 * @return false Aktuelle Zahl darf NICHT verwendet werden
	 * @return true Aktuelle Zahl darf verwendet werden
	 */
	public boolean proofedNumber(int[][] array, int bA, int hA, int aktNumber) {
		try {
			if (array[bA][hA] == aktNumber)
				return false;
		} catch (Exception e) {

		}
		return true;
	}

	/**
	 * Returns the contents of the quilt
	 * 
	 * @return The Array representing the patterns in the quilt
	 */
	public int[][] getContent() {
		return content;
	}
}